<template>
  <el-card shadow="never" class="aui-card--fill">
    <div class="mod-sys__user">
      <SearchBar :formConfigs="formConfig" ref="ruleForm" @headBtnClick="buttonClick">
        <!-- <el-badge :value="3" class="item">
          <el-button type="primary" size="small" @click="conditionSearch">条件搜索</el-button>
        </el-badge> -->
      </SearchBar>
      <base-table id="palletTable" :table-props="tableProps" :page="listQuery.page" ref="palletTable1"
        :limit="listQuery.limit" :table-data="tableData">
        <method-btn v-if="tableBtn.length" slot="handleBtn" :width="100" label="操作" :method-list="tableBtn"
          @clickBtn="handleClick" />
      </base-table>
      <pagination :limit.sync="listQuery.limit" :page.sync="listQuery.page" :total="listQuery.total"
        @pagination="getDataList" />
      <!-- 弹窗, 新增 / 修改 -->
      <base-dialog :dialogTitle="addOrEditTitle" :dialogVisible="addOrUpdateVisible" @cancel="handleCancel"
        @confirm="handleConfirm" :before-close="handleCancel">
        <customer-type-add ref="addOrUpdate" @refreshDataList="successSubmit"></customer-type-add>
        <!-- <el-row slot="footer" type="flex" justify="end"> </el-row> -->
      </base-dialog>
      <!-- <base-dialog :dialogTitle="searchOrEditTitle" :dialogVisible="searchOrUpdateVisible" @cancel="handleSearchCancel"
        @confirm="handleSearchConfirm" :before-close="handleSearchCancel">
        <customerType-search ref="searchOrUpdate" @successSubmit="conditionSearchSubmit"></customerType-search>
        <el-row slot="footer" type="flex" justify="end">
          <el-col :span="12">
            <el-button size="small" type="primary" plain class="btnTextStyle" @click="handleSearchCancel">
              {{ $t("close") }}
            </el-button>
            <el-button size="small" class="btnTextStyle" type="primary" plain @click="handleSearchReset">{{ $t("reset")
              }}</el-button>
            <el-button type="primary" size="small" class="btnTextStyle" @click="handleSearchConfirm">
              {{ $t("search") }}
            </el-button>
          </el-col>
        </el-row>
      </base-dialog> -->
    </div>
  </el-card>
</template>

<script>
import basicPage from "@/mixins/basic-page";
import basicSearch from "@/mixins/basic-search";
import customerTypeAdd from "./components/customerType-add";
// import customerTypeSearch from "./components/customerTypeSearch.vue";
import available from "./components/available.vue";
import Cookies from 'js-cookie'
import qs from 'qs'
// import radio from "./components/radio.vue";
import i18n from "@/i18n";
// import i18n from "@/i18n";
const tableProps = [
  {
    prop: "customerTypeCode",
    label: '编码'
  },
  {
    prop: "customerTypeName",
    label: "名称"
  },
  {
    prop: "customerTypeStatus",
    label: "状态",
    subcomponent: available,
  }
];
const tableBtn = [
  {
    type: "edit",
    btnName: "修改"
  },
  {
    type: "delete",
    btnName: "删除"
  }
];
export default {
  mixins: [basicPage],
  data() {
    return {
      urlOptions: {
        getDataListURL: "/basic/qmsCustomerType/page",
        deleteURL: "/basic/qmsCustomerType",
        exportURL: "/basic/qmsCustomerType/export",
      },
      tableProps,
      tableBtn,
      productData: {},
      addOrUpdateVisible:false,
      searchOrEditTitle: "",
      addOrEditTitle:'',
      searchOrUpdateVisible: false,
      productOrEditTitle: "",
      productOrUpdateVisible: false,
      formConfig: [
        {
          type: 'input',
          label: i18n.t('basic.name'),
          placeholder: i18n.t('basic.name'),
          param: 'name',
          clearable: true
        },
        {
          type: 'input',
          label: i18n.t('basic.code'),
          placeholder: i18n.t('basic.code'),
          param: 'code',
          clearable: true
        },
        {
          type: 'select',
          label: i18n.t('basic.status'),
          placeholder: i18n.t('basic.status'),
          param: 'status',
          selectOptions: [
            {
              id: '0',
              name: '不可用'
            },
            {
              id: '1',
              name: '可用'
            }
          ],
          clearable: true,
          filterable: true
        },
        {
          type: "button",
          btnName: "新增",
          name: "add",
          color: 'success',
          plain: true
          // plain: true,
        },
        {
          type: "button",
          btnName: "搜索",
          name: "search",
          color: "primary",
          // plain: true,
        },
        {
          type: "button",
          btnName: "导出",
          name: "export",
          color: 'primary',
          plain: true
          // plain: true,
        }
      ],
    };
  },
  components: {
    customerTypeAdd
  },
  methods: {
    //search-bar点击
    handleProductCancel() {
      this.productOrUpdateVisible = false;
      this.productOrEditTitle = "";
    },
    // handleSearchCancel() {
    //   this.searchOrEditTitle = "";
    //   this.searchOrUpdateVisible = false;
    // },
    conditionSearch() {
      this.searchOrEditTitle = "搜索";
      this.searchOrUpdateVisible = true;
      this.$nextTick(() => {
        this.$refs.searchOrUpdate.init();
      });
    },
    // handleConfirm() {
    //   this.$refs.addOrUpdate.dataFormSubmitHandle();
    // },
    // conditionSearchSubmit() {},
    conditionSearchSubmit(dataForm) {
      // console.log(key);
      // console.log(key);
      this.listQuery.name = dataForm.name
      this.listQuery.code = dataForm.code
      this.listQuery.status = dataForm.status
      this.listQuery.page = 1;
      this.getDataList();
      this.searchOrUpdateVisible = false;
      // console.log(11111);
      // this.conditionSearchSubmit();
    },
    exportHandle() {
      this.$http.get(this.urlOptions.exportURL, { responseType: 'blob' }, {
        ...this.dataForm
      }).then((res) => {
        console.log(res)
        // if (res !== 0) {
        //   return this.$message.error(res.msg) 
        // }
        let fileName = ''
        const contentDisposition = res.headers['content-disposition']
        if (contentDisposition) {
          const temp = res.headers['content-disposition']
            .split(';')[1]
            .split('=')[1]
          // 对文件名乱码转义--【Node.js】使用iconv-lite解决中文乱码
          fileName = decodeURI(temp)
          console.log(temp)
        }
        const blob = new Blob([res.data])
        const reader = new FileReader()
        reader.readAsDataURL(blob)
        reader.onload = (e) => {
          const a = document.createElement('a')
          a.download = fileName
          a.href = e.target.result
          document.body.appendChild(a)
          a.click()
          document.body.removeChild(a)
        }
      }).catch(() => { })
    },
    handleClick(val) {
      console.log(val);
      if (val.type === "delete") {
        this.$confirm(`确定对[名称=${val.data.customerTypeName}]进行删除操作?`, "提示", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning",
        })
          .then(() => {
            this.$http.delete(this.urlOptions.deleteURL, { data: [val.data.id] }).then(({ data }) => {
              if (data && data.code === 0) {
                this.$message({
                  message: "操作成功",
                  type: "success",
                  duration: 1500,
                  onClose: () => {
                    this.getDataList();
                  },
                });
              } else {
                this.$message.error(data.msg);
              }
            });
          })
          .catch(() => { });
      } else if (val.type === 'edit') {
        this.addOrUpdateVisible = true
        this.addOrEditTitle = this.$t('edit')
        this.$nextTick(() => {
          this.$refs.addOrUpdate.init(val.data.id);
        });
      }
    },
    buttonClick(val) {
      console.log(val);
      switch (val.btnName) {
        case "search":
          // this.listQuery.paramCode = val.paramCode;
          this.listQuery.name =val.name ?val.name : null
          this.listQuery.code = val.code ? val.code : null
          this.listQuery.status = val.status ? val.status : null
          // console.log(i18n);
          this.listQuery.page = 1;
          this.getDataList();
          break;
        case "export":
          this.exportHandle()
          break;
        case "add":
          this.addOrEditTitle = "新增";
          this.addOrUpdateVisible = true;
          this.$nextTick(() => {
            this.$refs.addOrUpdate.init();
          });
          break;
        // case "correlation":
        //   this.productOrEditTitle = "产品";
        //   this.productOrUpdateVisible = true;
        //   this.addOrUpdateHandle(this.productData);
        //   console.log(this.productId);
        //   break;
        // case "cancel":
        //   this.$refs.palletTable1.setCurrent("palletTable", -1);
        //   break;
        default:
          console.log(val);
      }
    },
  },
};
</script>
